dict = {'Incomplete URL sanitization': {'name': 'Incomplete URL sanitization', 'bid': 1, 'cwe': 20, 'qualname': ['\\burl\\s*=\\s*req\\.param\\(["\\\']url["\\\']\\)', 'url\\s*=\\s*request\\.args\\.get\\(["\\\']url["\\\']\\)', 'urlLib\\.parse\\(url\\)\\.hostname'], 'message': 'Improper Input Validation, Category A03:2021 - Injection', 'level': 'based on context'}, 'Tar Slip': {'name': 'Tar Slip', 'bid': 2, 'cwe': 22, 'qualname': ['\\b(input|raw_input|get|fetch|request)\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '[\\\'"]?(open|os\\.(system|popen|execve))\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\s*\\+\\s*[\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '\\b(eval|exec|execfile)\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '(\\b(subprocess\\.(Popen|check_output))|os\\.(system|popen|execve))\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '\\b(select|update|delete|insert)\\s.*\\b(from|where)\\s[\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?'], 'message': "CWE (22) Improper Limitation of a Pathname to a Restricted Directory ('Path Traversal'),Category A01:2021 - Broken Access Contro", 'level': 'based on context'}, 'Path Traversal': {'name': 'Path Traversal', 'bid': 3, 'cwe': 23, 'qualname': ['\\.\\./|\\.\\.|\\\\\\.\\\\\\.\\\\|\\\\\\.\\\\\\.'], 'message': 'Relative Path Traversal,  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, 'Command Injection': {'name': 'Command Injection', 'bid': 4, 'cwe': 78, 'qualname': ['os\\.system|subprocess\\.run|subprocess\\.call|subprocess\\.Popen'], 'message': "CWE (78) Improper Neutralization of Special Elements used in an OS Command ('OS Command Injection'),Category A03:2021 - Injection", 'level': 'based on context'}, 'Cross-site Scripting (XSS)': {'name': 'Cross-site Scripting (XSS)', 'bid': 5, 'cwe': 79, 'qualname': ['\\b(mark_safe)\\([\\\'"].*[\\\'"]\\)', '\\b(escape)\\([\\\'"].*[\\\'"]\\)', '\\b(html.escape)\\([\\\'"].*[\\\'"]\\)', '\\b(jinja2.escape)\\([\\\'"].*[\\\'"]\\)'], 'message': "CWE (79) Improper Neutralization of Input During Web Page Generation ('Cross-site Scripting'), Category A03:2021 - Injection", 'level': 'based on context'}, 'Jinja auto-escape is set to false': {'name': 'Jinja auto-escape is set to false', 'bid': 6, 'cwe': 79, 'qualname': ['\\{\\{.*\\}\\}', '\\{%.*%\\}'], 'message': "CWE (79) Improper Neutralization of Input During Web Page Generation ('Cross-site Scripting'), Category A03:2021 - Injection", 'level': 'based on context'}, 'SQL Injection': {'name': 'SQL Injection', 'bid': 7, 'cwe': 89, 'qualname': ['[\\s;]SELECT\\s.*\\sFROM\\s.*', '[\\s;]INSERT\\sINTO\\s.*\\sVALUES\\s.*', '[\\s;]UPDATE\\s.*\\sSET\\s.*', '[\\s;]DELETE\\sFROM\\s.*', '[\\s;]DROP\\sTABLE\\s.*', '[\\s;]TRUNCATE\\sTABLE\\s.*', '[\\s;]ALTER\\sTABLE\\s.*', '[\\s;]CREATE\\sTABLE\\s.*', '[\\s;]GRANT\\s.*\\sTO\\s.*', '[\\s;]REVOKE\\s.*\\sFROM\\s.*', '[\\s;]EXEC\\s.*', '[\\s;]CALL\\s.*'], 'message': "CWE (89) Improper Neutralization of Special Elements used in an SQL Command ('SQL Injection'),Category A03:2021 - Injection", 'level': 'based on context'}, 'Code Injection': {'name': 'Code Injection', 'bid': 8, 'cwe': 94, 'qualname': ['[\\s;]eval\\s*\\(.*\\)', '[\\s;]exec\\s*\\(.*\\)', '[\\s;]os\\.(system|popen|execve)\\(.*\\)', '[\\s;]subprocess\\.(Popen|check_output)\\(.*\\)', '[\\s;]input\\([\\\'"].*[\\\'"]\\)', '[\\s;](request|get|fetch)\\(.*\\)'], 'message': "CWE (94) Improper Control of Generation of Code ('Code Injection'),  Category A03:2021 - Injection", 'level': 'based on context'}, 'Static Code Injection': {'name': 'Static Code Injection', 'bid': 9, 'cwe': 96, 'qualname': ['[\\s;]eval\\s*\\(.*\\)', '[\\s;]exec\\s*\\(.*\\)', '[\\s;]os\\.(system|popen|execve)\\(.*\\)', '[\\s;]subprocess\\.(Popen|check_output)\\(.*\\)', '[\\s;]input\\([\\\'"].*[\\\'"]\\)', '[\\s;](request|get|fetch)\\(.*\\)'], 'message': " Improper Neutralization of Directives in Statically Saved Code ('Static Code Injection'),  Category A03:2021 - Injection", 'level': 'based on context'}, 'Server Information Exposure': {'name': 'Server Information Exposure', 'bid': 10, 'cwe': 209, 'qualname': ['\\b(server|platform|sys|os|uname)\\.platform\\b', '\\b(server|platform|sys|os|uname)\\.uname\\b', '\\b(server|platform|sys|os)\\.version\\b', '\\b(server|platform|sys|os)\\.release\\b', '\\b(server|platform|sys|os)\\.system\\b', '\\b(server|platform|sys|os)\\.cpu_count\\b'], 'message': 'CWE (209) Generation of Error Message Containing Sensitive Information,  Category A04:2021 - Insecure Design', 'level': 'based on context'}, 'Use of Hardcoded Credentials': {'name': 'Use of Hardcoded Credentials', 'bid': 11, 'cwe': 259, 'qualname': ['\\b(password|passwd|pwd)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(username|user|login)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(api_key|api_secret|token)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(secret_key|access_key)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(credentials|auth_token)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b'], 'message': 'CWE (259, 798) Use of Hard-coded Password, Use of Hard-coded Credentials,  Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, 'Insufficient Permissions or Privileges': {'name': 'Insufficient Permissions or Privileges', 'bid': 12, 'cwe': 280, 'qualname': ['\\bchmod\\(', '\\bchown\\(', '\\bsetuid\\(', '\\bsetgid\\(', '\\bseteuid\\(', '\\bsetegid\\(', '\\bsudo\\b', '\\broot\\b', '\\bprivileged\\b', '\\bgrant\\(', '\\bdeny\\(', '\\bpermission\\b', '\\bprivilege\\b'], 'message': ' Improper Handling of Insufficient Permissions or Privileges, Category A04:2021 - Insecure Desig', 'level': 'based on context'}, 'Improper Access Control': {'name': 'Improper Access Control', 'bid': 13, 'cwe': 284, 'qualname': ['\\b0\\.0\\.0\\.0\\b', '\\bsocket\\.bind\\(.*\\("0\\.0\\.0\\.0"', "\\bsocket\\.bind\\(.*\\(\\'0\\.0\\.0\\.0\\'"], 'message': 'CWE (284) Improper Access Control,  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, ' Broken User Authentication': {'name': ' Broken User Authentication', 'bid': 14, 'cwe': 287, 'qualname': ['\\blogin\\b', '\\bauthenticate\\b', '\\bcredentials\\b', '\\bpassword\\b', '\\bsession\\b', '\\btoken\\b', '\\bJWT\\b', '\\boauth\\b', '\\bauth\\b', '\\blogin_required\\b', '\\buser_authenticated\\b', '\\bvalidate_token\\b', '\\bsession_timeout\\b', '\\bremember_me\\b', '\\blogout\\b', '\\bunauthorized\\b'], 'message': 'Improper Authentication,  Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, 'Improper Certificate Validation': {'name': 'Improper Certificate Validation', 'bid': 15, 'cwe': 295, 'qualname': ['\\bssl\\.CERT_NONE\\b', '\\bssl\\.create_default_context\\(ssl\\.Purpose\\.(SERVER_AUTH|CLIENT_AUTH)\\)\\b', '\\bssl\\.match_hostname\\b', '\\bssl\\.CERT_OPTIONAL\\b', '\\bverify\\s*=\\s*False\\b', '\\bca_certs\\s*=\\s*None\\b', '\\bcheck_hostname\\s*=\\s*False\\b', '\\bvalidate_certificate\\b', '\\bssl\\.get_server_certificate\\b', '\\bssl\\.create_default_context\\(ssl\\.Purpose\\.(SERVER_AUTH|CLIENT_AUTH), cafile=.+\\)', '\\bssl\\.SSLContext\\.load_verify_locations\\(', '\\bssl\\.SSLContext\\.load_cert_chain\\(', '\\bvalidate_certificate_chain\\b'], 'message': 'Improper Certificate Validation,  Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, 'Cryptographic Issues': {'name': 'Cryptographic Issues', 'bid': 16, 'cwe': 310, 'qualname': ['\\bhashlib\\.(md5|sha1)\\(', '\\bCrypto\\.Hash\\.(MD2|MD4|MD5|SHA)\\.new\\(', '\\bcryptography\\.hazmat\\.primitives\\.hashes\\.(MD5|SHA1)\\(', '\\brandom\\.(Random|random|randrange|randint|choice|choices|uniform|triangular|randbytes)\\(', '\\bsecrets\\.(token_hex|token_bytes)\\(', '\\bCryptodome\\.(Cipher|PublicKey|Signature)\\.', '\\bcryptography\\.hazmat\\.(primitives\\.ciphers|primitives\\.asymmetric\\.rsa)\\.', '\\bparamiko\\.(RSAKey|DSAKey|EVPKey)\\(', '\\bhmac\\.(HMAC|new)\\(', '\\bcryptography\\.x509\\.(load_pem_x509_certificate|load_der_x509_certificate)\\(', '\\bcryptography\\.x509\\.(Certificate|CertificateBuilder)\\(', '\\bcryptography\\.fernet\\.', '\\bpickle\\.(load|loads)\\(', '\\bdill\\.(load|loads)\\(', '\\bjsonpickle\\.(decode|unpickler\\.decode)\\(', '\\bpandas\\.read_pickle\\(', '\\bpycryptodome\\.(PublicKey|Ciphertext)\\(', '\\bfernet\\.(Fernet|MultiFernet)\\(', '\\bpycryptodomex\\.(PublicKey|Ciphertext)\\('], 'message': ' Cryptographic Issues, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Authentication over HTTP': {'name': 'Authentication over HTTP', 'bid': 17, 'cwe': 310, 'qualname': ['\\bhttp\\.client\\.HTTPConnection\\(', '\\bhttp\\.client\\.HTTPSConnection\\(', '\\bhttp\\.client\\.HTTPResponse\\(', '\\bhttp\\.client\\.HTTPResponse\\.read\\(', '\\bhttp\\.client\\.HTTPResponse\\.readline\\(', '\\bhttp\\.client\\.HTTPResponse\\.getheaders\\(', '\\bhttp\\.client\\.HTTPResponse\\.getheader\\(', '\\bsocket\\.(socket|create_connection)\\(', '\\bsocket\\.socket\\.send\\(', '\\bsocket\\.socket\\.sendall\\(', '\\bsocket\\.socket\\.recv\\(', '\\bsocket\\.socket\\.recv_into\\(', '\\bos\\.(popen|system)\\(', '\\bos\\.execve\\(', '\\bftplib\\.(FTP|FTP_TLS)\\(', '\\bparamiko\\.(SSHClient|Transport)\\(', '\\bparamiko\\.SSHClient\\.connect\\(', '\\bsmtplib\\.(SMTP|SMTP_SSL)\\(', '\\bimaplib\\.(IMAP4|IMAP4_SSL)\\(', '\\bpoplib\\.(POP3|POP3_SSL)\\(', '\\bsmtplib\\.(sendmail|send_message|send_message|starttls)\\(', '\\bssl\\.(wrap_socket|create_default_context)\\(', '\\bssl\\.match_hostname\\('], 'message': 'CWE (319) Cleartext Transmission of Sensitive Information, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Hardcoded Cryptographic Key': {'name': 'Hardcoded Cryptographic Key', 'bid': 18, 'cwe': 259, 'qualname': ['\\b[A-Fa-f0-9]{32}\\b', '\\b[A-Fa-f0-9]{64}\\b', '\\b[A-Fa-f0-9]{128}\\b', '\\b[A-Za-z0-9+/]{44}={0,2}\\b', '\\b[A-Za-z0-9+/]{88}={0,2}\\b', '\\b[A-Za-z0-9+/]{176}={0,2}\\b', '\\b[A-Za-z0-9]{16}\\b', '\\b[A-Za-z0-9]{24}\\b', '\\b[A-Za-z0-9]{32}\\b', '\\b[A-Za-z0-9]{40}\\b', '\\b[A-Za-z0-9]{64}\\b', '\\b[A-Za-z0-9]{128}\\b', '\\b[A-Za-z0-9]{256}\\b', '\\b[A-Za-z0-9]{512}\\b', '\\b[A-Za-z0-9]{64}:[A-Za-z0-9]{64}\\b', '\\b0x[A-Fa-f0-9]{32}\\b', '\\b0x[A-Fa-f0-9]{64}\\b', '\\b0x[A-Fa-f0-9]{128}\\b', '\\b0x[A-Fa-f0-9]{16}\\b', '\\b0x[A-Fa-f0-9]{24}\\b', '\\b0x[A-Fa-f0-9]{32}\\b', '\\b0x[A-Fa-f0-9]{40}\\b', '\\b0x[A-Fa-f0-9]{64}\\b', '\\b0x[A-Fa-f0-9]{128}\\b', '\\b0x[A-Fa-f0-9]{256}\\b', '\\b0x[A-Fa-f0-9]{512}\\b', '\\b[A-Za-z0-9]+_[A-Za-z0-9]+_[A-Za-z0-9]+\\b'], 'message': 'CWE (321) Use of Hard-coded Cryptographic Key, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Inadequate Encryption Strength': {'name': 'Inadequate Encryption Strength', 'bid': 19, 'cwe': 326, 'qualname': ['\\bMD2\\b', '\\bMD4\\b', '\\bMD5\\b', '\\bDES\\b', '\\b3DES\\b|\\bTriple DES\\b|\\bTDES\\b', '\\bRC4\\b', '\\bRC5\\b', '\\bRC6\\b', '\\bSingle DES\\b|\\bSingle-DES\\b', '\\bSHA-1\\b', '\\bRSA\\b', '\\bAES-128\\b', '\\bAES-192\\b', '\\bAES-256\\b', '\\b128-bit\\b', '\\b192-bit\\b', '\\b256-bit\\b', '\\bLow encryption strength\\b', '\\bWeak encryption strength\\b', '\\bInadequate encryption\\b'], 'message': 'CWE (326) Inadequate Encryption Strength, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Broken or Risky Cryptographic Algorithm': {'name': 'Broken or Risky Cryptographic Algorithm', 'bid': 20, 'cwe': 327, 'qualname': ['\\bMD2\\b', '\\bMD4\\b', '\\bMD5\\b', '\\bSHA-1\\b', '\\bRC4\\b', '\\bRC5\\b', '\\bRC6\\b', '\\bDES\\b', '\\bTriple DES\\b|\\b3DES\\b|\\bTDES\\b', '\\bSingle DES\\b|\\bSingle-DES\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b', '\\bMD5\\b', '\\bSHA\\b', '\\bMD4\\b', '\\bMD5\\b', '\\bRC4\\b', '\\bRC5\\b', '\\bRC6\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b', '\\bSHA\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b'], 'message': 'CWE (327) Use of a Broken or Risky Cryptographic Algorithm,  Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, ' Missing protocol in ssl.wrap_socket': {'name': ' Missing protocol in ssl.wrap_socket', 'bid': 21, 'cwe': 327, 'qualname': ['ssl\\.wrap_socket\\((?![^,]*protocol\\s*=\\s*ssl\\.PROTOCOL_TLS)(?![^,]*protocol\\s*=\\s*ssl\\.PROTOCOL_SSL)'], 'message': 'Use of a Broken or Risky Cryptographic Algorithm, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Use of Hardcoded Cryptographic Initialization Value': {'name': 'Use of Hardcoded Cryptographic Initialization Value', 'bid': 22, 'cwe': 329, 'qualname': ['IV\\s*=\\s*b[\\\'"]\\s*.\\s*join\\s*\\(\\s*[\\\'"].*[\\\'"].*rand.*\\(.*\\)', 'IV\\s*=\\s*os\\.urandom\\(\\s*\\d+\\s*\\)', 'IV\\s*=\\s*urandom\\(\\s*\\d+\\s*\\)', 'IV\\s*=\\s*Random\\.new\\(\\s*SAME\\s*\\)', 'IV\\s*=\\s*"\\s*.{16}\\s*"', 'IV\\s*=\\s*b[\\\'"].{16}[\\\'"]', 'IV\\s*=\\s*b[\\\'"]\\s*.\\s*join\\s*\\(\\s*map\\s*\\(.*\\)', 'IV\\s*=\\s*b[\\\'"].{16}[\\\'"]', 'IV\\s*=\\s*bytes\\([0-9,\\s]*\\)', 'IV\\s*=\\s*bytearray\\([0-9,\\s]*\\)'], 'message': 'CWE (329) Generation of Predictable IV with CBC Mode,  Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Origin Validation Error': {'name': 'Origin Validation Error', 'bid': 23, 'cwe': 346, 'qualname': ['origin\\s*=\\s*request\\.headers\\.get\\(["\\\']Origin["\\\']\\)', 'if\\s*origin\\s*!=\\s*trusted_origin:', 'if\\s*not\\s*validate_origin\\(origin\\):', 'origin\\s*=\\s*request\\.headers\\.get\\(["\\\']Referer["\\\']\\)', 'if\\s*not\\s*origin\\s*or\\s*not\\s*is_valid_origin\\(origin\\):', 'origin\\s*=\\s*request\\.headers\\.get\\(["\\\']Host["\\\']\\)'], 'message': 'CWE (346, 942) Origin Validation Error, Permissive Cross-domain Policy with Untrusted Domains, Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, 'Cross-Site Request Forgery (CSRF)': {'name': 'Cross-Site Request Forgery (CSRF)', 'bid': 24, 'cwe': 352, 'qualname': ['csrf_token\\s*=\\s*request\\.cookies\\.get\\(["\\\']csrf_token["\\\']\\)', 'csrf_token\\s*=\\s*request\\.headers\\.get\\(["\\\']X-CSRF-Token["\\\']\\)', 'csrf_token\\s*=\\s*request\\.args\\.get\\(["\\\']csrf_token["\\\']\\)', 'csrf_token\\s*=\\s*request\\.form\\.get\\(["\\\']csrf_token["\\\']\\)', 'if\\s*csrf_token\\s*!=\\s*session\\["\\\']csrf_token["\\\']:', 'if\\s*csrf_token\\s*!=\\s*request\\.headers\\.get\\(["\\\']X-CSRF-Token["\\\']\\):', 'if\\s*csrf_token\\s*!=\\s*request\\.args\\.get\\(["\\\']csrf_token["\\\']\\):', 'if\\s*csrf_token\\s*!=\\s*request\\.form\\.get\\(["\\\']csrf_token["\\\']\\):', 'csrf_token\\s*=\\s*request\\.cookies\\.get\\(["\\\']csrf_token["\\\']\\)', 'if\\s*not\\s*validate_csrf_token\\(csrf_token\\):'], 'message': 'CWE (352) Cross-Site Request Forgery (CSRF),  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, 'Insecure Temporary File': {'name': 'Insecure Temporary File', 'bid': 25, 'cwe': 732, 'qualname': ['tempfile\\.mktemp\\(', 'tempfile\\.TemporaryFile\\(', 'open\\(.*[, ]["\\\']w[+"\\\']\\)', 'open\\(.*[, ]["\\\']a[+"\\\']\\)', 'file\\.write\\(.*request\\.data\\)', 'file\\.write\\(.*input\\("Enter file contents: "\\)\\)', 'file\\.write\\(.*input\\("Enter file name: "\\)\\)', 'file\\.write\\(.*sys\\.argv\\[\\d\\]\\)', 'file\\.write\\(.*os\\.getenv\\("TEMP"\\)\\)'], 'message': 'CWE (377) Insecure Temporary File,  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, 'Regular Expression Denial of Service (ReDoS': {'name': 'Regular Expression Denial of Service (ReDoS', 'bid': 26, 'cwe': 400, 'qualname': ['\\b\\w*(\\w)\\1{3,}\\w*\\b', '\\b\\d+(\\d+)\\1{3,}\\d*\\b', '\\b[A-Za-z0-9_]+(?:\\.[A-Za-z0-9_]+)*@[A-Za-z0-9_]+(?:\\.[A-Za-z0-9_]+)+\\b', '\\b[a-z]+(?:-[a-z]+)*\\b', '\\b(?:[a-z]+)+\\b', '([a-zA-Z]+)\\1{4,}', '(a+)+\\s(b+)+', '^(a+)+$', '\\b[A-Za-z]+\\b'], 'message': 'CWE (400) Uncontrolled Resource Consumption', 'level': 'based on context'}, 'Insecure default value': {'name': 'Insecure default value', 'bid': 27, 'cwe': 400, 'qualname': ['password\\s*=\\s*[\\\'"].*[\\\'"]', 'api_key\\s*=\\s*[\\\'"].*[\\\'"]', 'secret_key\\s*=\\s*[\\\'"].*[\\\'"]', 'token\\s*=\\s*[\\\'"].*[\\\'"]', 'key\\s*=\\s*[\\\'"].*[\\\'"]', 'passphrase\\s*=\\s*[\\\'"].*[\\\'"]', 'auth\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.username\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.password\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.key\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.secret\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.token\\s*=\\s*[\\\'"].*[\\\'"]'], 'message': 'CWE (453) Insecure Default Variable Initialization', 'level': 'based on context'}, 'Debug Mode Enabled': {'name': 'Debug Mode Enabled', 'bid': 28, 'cwe': 489, 'qualname': ['debug\\s*=\\s*(True|true|1)', 'debug\\s*=\\s*(\\\'|\\")?on(\\\'|\\")?', 'debug\\s*=\\s*[\\\'"]?enabled[\\\'"]?', 'debug\\s*=\\s*(\\\'|\\")?yes(\\\'|\\")?'], 'message': 'CWE (489) Active Debug Code', 'level': 'based on context'}, 'Deserialization of Untrusted Data': {'name': 'Deserialization of Untrusted Data', 'bid': 29, 'cwe': 502, 'qualname': ['pickle\\.loads\\(', 'pickle\\.load\\(', 'dill\\.loads\\(', 'dill\\.load\\(', 'shelve\\.open\\(', 'jsonpickle\\.decode\\(', 'pandas\\.read_pickle\\(', 'marshal\\.loads\\(', 'marshal\\.load\\('], 'message': 'CWE (502) Deserialization of Untrusted Data, Category A08:2021 - Software and Data Integrity Failures', 'level': 'based on context'}, 'Hardcoded Secret': {'name': 'Hardcoded Secret', 'bid': 30, 'cwe': 547, 'qualname': ['password\\s*=\\s*[\\\'"].*[\\\'"]', 'api_key\\s*=\\s*[\\\'"].*[\\\'"]', 'token\\s*=\\s*[\\\'"].*[\\\'"]', 'secret\\s*=\\s*[\\\'"].*[\\\'"]'], 'message': 'CWE (547) Use of Hard-coded, Security-relevant Constants, Category A05:2021 - Security Misconfiguration', 'level': 'based on context'}, ' Open Redirect': {'name': ' Open Redirect', 'bid': 31, 'cwe': 601, 'qualname': ['redirect\\s*=\\s*[\\\'"].*[\\\'"]', 'redirect_url\\s*=\\s*[\\\'"].*[\\\'"]', 'url\\s*=\\s*[\\\'"].*[\\\'"]', 'location\\s*=\\s*[\\\'"].*[\\\'"]', 'window\\.location\\s*=\\s*[\\\'"].*[\\\'"]'], 'message': "CWE (601) URL Redirection to Untrusted Site ('Open Redirect'), Category A01:2021 - Broken Access Control", 'level': 'based on context'}, 'Insecure Xml Parser': {'name': 'Insecure Xml Parser', 'bid': 32, 'cwe': 611, 'qualname': ['xml\\.etree\\.cElementTree\\.parse', 'xml\\.etree\\.ElementTree\\.parse', 'xml\\.sax\\.parse', 'xml\\.dom\\.minidom\\.parse', 'xml\\.dom\\.pulldom\\.parse', 'lxml\\.etree\\.parse', 'lxml\\.etree\\.fromstring', 'lxml\\.etree\\.RestrictedElement', 'lxml\\.etree\\.GlobalParserTLS', 'lxml\\.etree\\.getDefaultParser', 'lxml\\.etree\\.check_docinfo'], 'message': 'CWE (611) Improper Restriction of XML External Entity Reference, Category A05:2021 - Security Misconfiguration', 'level': 'based on context'}, "Sensitive Cookie in HTTPS Session Without 'Secure' Attribute": {'name': "Sensitive Cookie in HTTPS Session Without 'Secure' Attribute", 'bid': 33, 'cwe': 614, 'qualname': ['set-cookie:\\s*(?i)(?!.*\\bsecure\\b)(?=.*\\b(?:sessionid|auth|token)\\b)'], 'message': "CWE (614) Sensitive Cookie in HTTPS Session Without 'Secure' Attribute,  Category A05:2021 - Security Misconfiguration", 'level': 'based on context'}, ' XPath Injection': {'name': ' XPath Injection', 'bid': 34, 'cwe': 643, 'qualname': ['\\.xpath\\(\\s*["\\\'][^"\\\']*{{user_input}}[^"\\\']*["\\\']\\s*\\)'], 'message': "CWE (643) Improper Neutralization of Data within XPath Expressions ('XPath Injection'), Category A03:2021 - Injection", 'level': 'based on context'}, 'Insecure File Permissions': {'name': 'Insecure File Permissions', 'bid': 35, 'cwe': 732, 'qualname': ['os\\.chmod\\(|os\\.chown\\(|os\\.umask\\(|os\\.open\\(|open\\(|os\\.makedirs\\(|shutil\\.copy2\\(|shutil\\.move\\(|os\\.rename\\(|tempfile\\.mkstemp\\(|tempfile\\.NamedTemporaryFile\\(|tempfile\\.TemporaryFile\\(|os\\.fdopen\\(|os\\.lchown\\(|os\\.chmod\\(|os\\.fchmod\\(|os\\.lchmod\\(|os\\.open\\(|os\\.mknod\\(|os\\.mmap\\(|os\\.utime\\('], 'message': 'CWE (732) Incorrect Permission Assignment for Critical Resource', 'level': 'based on context'}, 'Selection of Less-Secure Algorithm During Negotiation (SSL instead of TLS)': {'name': 'Selection of Less-Secure Algorithm During Negotiation (SSL instead of TLS)', 'bid': 36, 'cwe': 327, 'qualname': ['ssl\\.(PROTOCOL_SSLv23|SSLContext|wrap_socket|create_default_context|_create_unverified_context)'], 'message': "CWE (757) Selection of Less-Secure Algorithm During Negotiation ('Algorithm Downgrade'),  Category A02:2021 - Cryptographic Failures", 'level': 'based on context'}, 'Use of Password Hash With Insufficient Computational Effort': {'name': 'Use of Password Hash With Insufficient Computational Effort', 'bid': 37, 'cwe': 916, 'qualname': ['crypt\\.(crypt|crypt_sha256|crypt_sha512)|hashlib\\.(md5|sha1)', 'bcrypt\\.(hashpw|gensalt)', 'argon2\\.(hash_password|Hasher\\.hash\\(|PasswordHasher\\()', 'scrypt\\.(hash|encrypt)', 'passlib\\.(hash|pwd\\.)', '\\bPBKDF2\\b', '\\bsha256_crypt\\b', '\\bsha512_crypt\\b', '\\bmd5_crypt\\b', '\\bsha1_crypt\\b', '\\bsha256_pbkdf2\\b', '\\bsha512_pbkdf2\\b', '\\bargon2_cffi\\b', '\\bpycryptodome\\.(pbkdf2|hashers)\\b', '\\bpy-bcrypt\\b'], 'message': 'CWE (916) Use of Password Hash With Insufficient Computational Effort, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, 'Server-Side Request Forgery (SSRF)': {'name': 'Server-Side Request Forgery (SSRF)', 'bid': 38, 'cwe': 918, 'qualname': ['\\burllib\\.request\\.(urlopen|urlretrieve|URLopener|FancyURLopener)|\\brequests\\.(get|head|post|put|patch|delete)', '\\bhttplib2\\.Http\\.request|tornado\\.httpclient\\.HTTPClient\\.fetch|aiohttp\\.ClientSession\\.(get|post|put|patch|delete)', '\\bhttp\\.client\\.HTTPConnection\\.request|http\\.client\\.HTTPSConnection\\.request', '\\bsocket\\.socket\\.connect\\b', '\\bparamiko\\.SSHClient\\.connect\\b', '\\bfabric\\.Connection\\.connect\\b', '\\bparamiko\\.SFTPClient\\.from_transport\\b', '\\bsocketserver\\.(TCPServer|UDPServer)\\b'], 'message': 'CWE (918) Server-Side Request Forgery (SSRF),  Category A10:2021 - Server-Side Request Forgery (SSRF)', 'level': 'based on context'}, 'NoSQL Injection': {'name': 'NoSQL Injection', 'bid': 39, 'cwe': 943, 'qualname': ['\\bfind_one\\b', '\\bfind\\b', '\\bfind_and_modify\\b', '\\baggregate\\b', '\\bupdate\\b', '\\bremove\\b', '\\bdelete_one\\b', '\\bdelete_many\\b', '\\binsert\\b', '\\binsert_one\\b', '\\binsert_many\\b', '\\breplace_one\\b', '\\bdistinct\\b', '\\bmap_reduce\\b', '\\bdatabase\\.query\\b', '\\bdatabase\\.execute\\b', '\\bexecute_query\\b'], 'message': 'CWE (943) Improper Neutralization of Special Elements in Data Query Logic', 'level': 'based on context'}, "Sensitive Cookie Without 'HttpOnly' Flag": {'name': "Sensitive Cookie Without 'HttpOnly' Flag", 'bid': 40, 'cwe': 1004, 'qualname': ['\\bset_cookie\\([^\\)]*HttpOnly\\b', '\\bSet-Cookie:.*HttpOnly\\b'], 'message': "CWE (1004) Sensitive Cookie Without 'HttpOnly' Flag, Category A05:2021 - Security Misconfiguration", 'level': 'based on context'}, ' Python 2 source code': {'name': ' Python 2 source code', 'bid': 41, 'cwe': 1104, 'qualname': ['\\bimport\\s+unmaintained_module\\b', '\\bfrom\\s+unmaintained_package\\b', '\\bunmaintained_module\\b', '\\bunmaintained_package\\b', "\\brequire\\(\\'unmaintained_package\\'\\)", '\\bimport \\(require\\("unmaintained_package"\\)\\)'], 'message': 'CWE (1104) Use of Unmaintained Third Party Components, Category A06:2021 - Vulnerable and Outdated Components', 'level': 'based on context'}}
blist = [{'name': 'Incomplete URL sanitization', 'bid': 1, 'cwe': 20, 'qualname': ['\\burl\\s*=\\s*req\\.param\\(["\\\']url["\\\']\\)', 'url\\s*=\\s*request\\.args\\.get\\(["\\\']url["\\\']\\)', 'urlLib\\.parse\\(url\\)\\.hostname'], 'message': 'Improper Input Validation, Category A03:2021 - Injection', 'level': 'based on context'}, {'name': 'Tar Slip', 'bid': 2, 'cwe': 22, 'qualname': ['\\b(input|raw_input|get|fetch|request)\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '[\\\'"]?(open|os\\.(system|popen|execve))\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\s*\\+\\s*[\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '\\b(eval|exec|execfile)\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '(\\b(subprocess\\.(Popen|check_output))|os\\.(system|popen|execve))\\([\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?\\)', '\\b(select|update|delete|insert)\\s.*\\b(from|where)\\s[\\\'"]?[a-zA-Z_][a-zA-Z0-9_]*[\\\'"]?'], 'message': "CWE (22) Improper Limitation of a Pathname to a Restricted Directory ('Path Traversal'),Category A01:2021 - Broken Access Contro", 'level': 'based on context'}, {'name': 'Path Traversal', 'bid': 3, 'cwe': 23, 'qualname': ['\\.\\./|\\.\\.|\\\\\\.\\\\\\.\\\\|\\\\\\.\\\\\\.'], 'message': 'Relative Path Traversal,  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, {'name': 'Command Injection', 'bid': 4, 'cwe': 78, 'qualname': ['os\\.system|subprocess\\.run|subprocess\\.call|subprocess\\.Popen'], 'message': "CWE (78) Improper Neutralization of Special Elements used in an OS Command ('OS Command Injection'),Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'Cross-site Scripting (XSS)', 'bid': 5, 'cwe': 79, 'qualname': ['\\b(mark_safe)\\([\\\'"].*[\\\'"]\\)', '\\b(escape)\\([\\\'"].*[\\\'"]\\)', '\\b(html.escape)\\([\\\'"].*[\\\'"]\\)', '\\b(jinja2.escape)\\([\\\'"].*[\\\'"]\\)'], 'message': "CWE (79) Improper Neutralization of Input During Web Page Generation ('Cross-site Scripting'), Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'Jinja auto-escape is set to false', 'bid': 6, 'cwe': 79, 'qualname': ['\\{\\{.*\\}\\}', '\\{%.*%\\}'], 'message': "CWE (79) Improper Neutralization of Input During Web Page Generation ('Cross-site Scripting'), Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'SQL Injection', 'bid': 7, 'cwe': 89, 'qualname': ['[\\s;]SELECT\\s.*\\sFROM\\s.*', '[\\s;]INSERT\\sINTO\\s.*\\sVALUES\\s.*', '[\\s;]UPDATE\\s.*\\sSET\\s.*', '[\\s;]DELETE\\sFROM\\s.*', '[\\s;]DROP\\sTABLE\\s.*', '[\\s;]TRUNCATE\\sTABLE\\s.*', '[\\s;]ALTER\\sTABLE\\s.*', '[\\s;]CREATE\\sTABLE\\s.*', '[\\s;]GRANT\\s.*\\sTO\\s.*', '[\\s;]REVOKE\\s.*\\sFROM\\s.*', '[\\s;]EXEC\\s.*', '[\\s;]CALL\\s.*'], 'message': "CWE (89) Improper Neutralization of Special Elements used in an SQL Command ('SQL Injection'),Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'Code Injection', 'bid': 8, 'cwe': 94, 'qualname': ['[\\s;]eval\\s*\\(.*\\)', '[\\s;]exec\\s*\\(.*\\)', '[\\s;]os\\.(system|popen|execve)\\(.*\\)', '[\\s;]subprocess\\.(Popen|check_output)\\(.*\\)', '[\\s;]input\\([\\\'"].*[\\\'"]\\)', '[\\s;](request|get|fetch)\\(.*\\)'], 'message': "CWE (94) Improper Control of Generation of Code ('Code Injection'),  Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'Static Code Injection', 'bid': 9, 'cwe': 96, 'qualname': ['[\\s;]eval\\s*\\(.*\\)', '[\\s;]exec\\s*\\(.*\\)', '[\\s;]os\\.(system|popen|execve)\\(.*\\)', '[\\s;]subprocess\\.(Popen|check_output)\\(.*\\)', '[\\s;]input\\([\\\'"].*[\\\'"]\\)', '[\\s;](request|get|fetch)\\(.*\\)'], 'message': " Improper Neutralization of Directives in Statically Saved Code ('Static Code Injection'),  Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'Server Information Exposure', 'bid': 10, 'cwe': 209, 'qualname': ['\\b(server|platform|sys|os|uname)\\.platform\\b', '\\b(server|platform|sys|os|uname)\\.uname\\b', '\\b(server|platform|sys|os)\\.version\\b', '\\b(server|platform|sys|os)\\.release\\b', '\\b(server|platform|sys|os)\\.system\\b', '\\b(server|platform|sys|os)\\.cpu_count\\b'], 'message': 'CWE (209) Generation of Error Message Containing Sensitive Information,  Category A04:2021 - Insecure Design', 'level': 'based on context'}, {'name': 'Use of Hardcoded Credentials', 'bid': 11, 'cwe': 259, 'qualname': ['\\b(password|passwd|pwd)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(username|user|login)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(api_key|api_secret|token)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(secret_key|access_key)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b', '\\b(credentials|auth_token)\\s*=\\s*[\\\'"][^\\\'"]+[\\\'"]\\b'], 'message': 'CWE (259, 798) Use of Hard-coded Password, Use of Hard-coded Credentials,  Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, {'name': 'Insufficient Permissions or Privileges', 'bid': 12, 'cwe': 280, 'qualname': ['\\bchmod\\(', '\\bchown\\(', '\\bsetuid\\(', '\\bsetgid\\(', '\\bseteuid\\(', '\\bsetegid\\(', '\\bsudo\\b', '\\broot\\b', '\\bprivileged\\b', '\\bgrant\\(', '\\bdeny\\(', '\\bpermission\\b', '\\bprivilege\\b'], 'message': ' Improper Handling of Insufficient Permissions or Privileges, Category A04:2021 - Insecure Desig', 'level': 'based on context'}, {'name': 'Improper Access Control', 'bid': 13, 'cwe': 284, 'qualname': ['\\b0\\.0\\.0\\.0\\b', '\\bsocket\\.bind\\(.*\\("0\\.0\\.0\\.0"', "\\bsocket\\.bind\\(.*\\(\\'0\\.0\\.0\\.0\\'"], 'message': 'CWE (284) Improper Access Control,  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, {'name': ' Broken User Authentication', 'bid': 14, 'cwe': 287, 'qualname': ['\\blogin\\b', '\\bauthenticate\\b', '\\bcredentials\\b', '\\bpassword\\b', '\\bsession\\b', '\\btoken\\b', '\\bJWT\\b', '\\boauth\\b', '\\bauth\\b', '\\blogin_required\\b', '\\buser_authenticated\\b', '\\bvalidate_token\\b', '\\bsession_timeout\\b', '\\bremember_me\\b', '\\blogout\\b', '\\bunauthorized\\b'], 'message': 'Improper Authentication,  Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, {'name': 'Improper Certificate Validation', 'bid': 15, 'cwe': 295, 'qualname': ['\\bssl\\.CERT_NONE\\b', '\\bssl\\.create_default_context\\(ssl\\.Purpose\\.(SERVER_AUTH|CLIENT_AUTH)\\)\\b', '\\bssl\\.match_hostname\\b', '\\bssl\\.CERT_OPTIONAL\\b', '\\bverify\\s*=\\s*False\\b', '\\bca_certs\\s*=\\s*None\\b', '\\bcheck_hostname\\s*=\\s*False\\b', '\\bvalidate_certificate\\b', '\\bssl\\.get_server_certificate\\b', '\\bssl\\.create_default_context\\(ssl\\.Purpose\\.(SERVER_AUTH|CLIENT_AUTH), cafile=.+\\)', '\\bssl\\.SSLContext\\.load_verify_locations\\(', '\\bssl\\.SSLContext\\.load_cert_chain\\(', '\\bvalidate_certificate_chain\\b'], 'message': 'Improper Certificate Validation,  Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, {'name': 'Cryptographic Issues', 'bid': 16, 'cwe': 310, 'qualname': ['\\bhashlib\\.(md5|sha1)\\(', '\\bCrypto\\.Hash\\.(MD2|MD4|MD5|SHA)\\.new\\(', '\\bcryptography\\.hazmat\\.primitives\\.hashes\\.(MD5|SHA1)\\(', '\\brandom\\.(Random|random|randrange|randint|choice|choices|uniform|triangular|randbytes)\\(', '\\bsecrets\\.(token_hex|token_bytes)\\(', '\\bCryptodome\\.(Cipher|PublicKey|Signature)\\.', '\\bcryptography\\.hazmat\\.(primitives\\.ciphers|primitives\\.asymmetric\\.rsa)\\.', '\\bparamiko\\.(RSAKey|DSAKey|EVPKey)\\(', '\\bhmac\\.(HMAC|new)\\(', '\\bcryptography\\.x509\\.(load_pem_x509_certificate|load_der_x509_certificate)\\(', '\\bcryptography\\.x509\\.(Certificate|CertificateBuilder)\\(', '\\bcryptography\\.fernet\\.', '\\bpickle\\.(load|loads)\\(', '\\bdill\\.(load|loads)\\(', '\\bjsonpickle\\.(decode|unpickler\\.decode)\\(', '\\bpandas\\.read_pickle\\(', '\\bpycryptodome\\.(PublicKey|Ciphertext)\\(', '\\bfernet\\.(Fernet|MultiFernet)\\(', '\\bpycryptodomex\\.(PublicKey|Ciphertext)\\('], 'message': ' Cryptographic Issues, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Authentication over HTTP', 'bid': 17, 'cwe': 310, 'qualname': ['\\bhttp\\.client\\.HTTPConnection\\(', '\\bhttp\\.client\\.HTTPSConnection\\(', '\\bhttp\\.client\\.HTTPResponse\\(', '\\bhttp\\.client\\.HTTPResponse\\.read\\(', '\\bhttp\\.client\\.HTTPResponse\\.readline\\(', '\\bhttp\\.client\\.HTTPResponse\\.getheaders\\(', '\\bhttp\\.client\\.HTTPResponse\\.getheader\\(', '\\bsocket\\.(socket|create_connection)\\(', '\\bsocket\\.socket\\.send\\(', '\\bsocket\\.socket\\.sendall\\(', '\\bsocket\\.socket\\.recv\\(', '\\bsocket\\.socket\\.recv_into\\(', '\\bos\\.(popen|system)\\(', '\\bos\\.execve\\(', '\\bftplib\\.(FTP|FTP_TLS)\\(', '\\bparamiko\\.(SSHClient|Transport)\\(', '\\bparamiko\\.SSHClient\\.connect\\(', '\\bsmtplib\\.(SMTP|SMTP_SSL)\\(', '\\bimaplib\\.(IMAP4|IMAP4_SSL)\\(', '\\bpoplib\\.(POP3|POP3_SSL)\\(', '\\bsmtplib\\.(sendmail|send_message|send_message|starttls)\\(', '\\bssl\\.(wrap_socket|create_default_context)\\(', '\\bssl\\.match_hostname\\('], 'message': 'CWE (319) Cleartext Transmission of Sensitive Information, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Hardcoded Cryptographic Key', 'bid': 18, 'cwe': 259, 'qualname': ['\\b[A-Fa-f0-9]{32}\\b', '\\b[A-Fa-f0-9]{64}\\b', '\\b[A-Fa-f0-9]{128}\\b', '\\b[A-Za-z0-9+/]{44}={0,2}\\b', '\\b[A-Za-z0-9+/]{88}={0,2}\\b', '\\b[A-Za-z0-9+/]{176}={0,2}\\b', '\\b[A-Za-z0-9]{16}\\b', '\\b[A-Za-z0-9]{24}\\b', '\\b[A-Za-z0-9]{32}\\b', '\\b[A-Za-z0-9]{40}\\b', '\\b[A-Za-z0-9]{64}\\b', '\\b[A-Za-z0-9]{128}\\b', '\\b[A-Za-z0-9]{256}\\b', '\\b[A-Za-z0-9]{512}\\b', '\\b[A-Za-z0-9]{64}:[A-Za-z0-9]{64}\\b', '\\b0x[A-Fa-f0-9]{32}\\b', '\\b0x[A-Fa-f0-9]{64}\\b', '\\b0x[A-Fa-f0-9]{128}\\b', '\\b0x[A-Fa-f0-9]{16}\\b', '\\b0x[A-Fa-f0-9]{24}\\b', '\\b0x[A-Fa-f0-9]{32}\\b', '\\b0x[A-Fa-f0-9]{40}\\b', '\\b0x[A-Fa-f0-9]{64}\\b', '\\b0x[A-Fa-f0-9]{128}\\b', '\\b0x[A-Fa-f0-9]{256}\\b', '\\b0x[A-Fa-f0-9]{512}\\b', '\\b[A-Za-z0-9]+_[A-Za-z0-9]+_[A-Za-z0-9]+\\b'], 'message': 'CWE (321) Use of Hard-coded Cryptographic Key, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Inadequate Encryption Strength', 'bid': 19, 'cwe': 326, 'qualname': ['\\bMD2\\b', '\\bMD4\\b', '\\bMD5\\b', '\\bDES\\b', '\\b3DES\\b|\\bTriple DES\\b|\\bTDES\\b', '\\bRC4\\b', '\\bRC5\\b', '\\bRC6\\b', '\\bSingle DES\\b|\\bSingle-DES\\b', '\\bSHA-1\\b', '\\bRSA\\b', '\\bAES-128\\b', '\\bAES-192\\b', '\\bAES-256\\b', '\\b128-bit\\b', '\\b192-bit\\b', '\\b256-bit\\b', '\\bLow encryption strength\\b', '\\bWeak encryption strength\\b', '\\bInadequate encryption\\b'], 'message': 'CWE (326) Inadequate Encryption Strength, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Broken or Risky Cryptographic Algorithm', 'bid': 20, 'cwe': 327, 'qualname': ['\\bMD2\\b', '\\bMD4\\b', '\\bMD5\\b', '\\bSHA-1\\b', '\\bRC4\\b', '\\bRC5\\b', '\\bRC6\\b', '\\bDES\\b', '\\bTriple DES\\b|\\b3DES\\b|\\bTDES\\b', '\\bSingle DES\\b|\\bSingle-DES\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b', '\\bMD5\\b', '\\bSHA\\b', '\\bMD4\\b', '\\bMD5\\b', '\\bRC4\\b', '\\bRC5\\b', '\\bRC6\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b', '\\bSHA\\b', '\\bECB\\b', '\\bCBC\\b', '\\bCFB\\b', '\\bOFB\\b', '\\bPKCS1\\b', '\\bPKCS5\\b', '\\bPKCS7\\b'], 'message': 'CWE (327) Use of a Broken or Risky Cryptographic Algorithm,  Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': ' Missing protocol in ssl.wrap_socket', 'bid': 21, 'cwe': 327, 'qualname': ['ssl\\.wrap_socket\\((?![^,]*protocol\\s*=\\s*ssl\\.PROTOCOL_TLS)(?![^,]*protocol\\s*=\\s*ssl\\.PROTOCOL_SSL)'], 'message': 'Use of a Broken or Risky Cryptographic Algorithm, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Use of Hardcoded Cryptographic Initialization Value', 'bid': 22, 'cwe': 329, 'qualname': ['IV\\s*=\\s*b[\\\'"]\\s*.\\s*join\\s*\\(\\s*[\\\'"].*[\\\'"].*rand.*\\(.*\\)', 'IV\\s*=\\s*os\\.urandom\\(\\s*\\d+\\s*\\)', 'IV\\s*=\\s*urandom\\(\\s*\\d+\\s*\\)', 'IV\\s*=\\s*Random\\.new\\(\\s*SAME\\s*\\)', 'IV\\s*=\\s*"\\s*.{16}\\s*"', 'IV\\s*=\\s*b[\\\'"].{16}[\\\'"]', 'IV\\s*=\\s*b[\\\'"]\\s*.\\s*join\\s*\\(\\s*map\\s*\\(.*\\)', 'IV\\s*=\\s*b[\\\'"].{16}[\\\'"]', 'IV\\s*=\\s*bytes\\([0-9,\\s]*\\)', 'IV\\s*=\\s*bytearray\\([0-9,\\s]*\\)'], 'message': 'CWE (329) Generation of Predictable IV with CBC Mode,  Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Origin Validation Error', 'bid': 23, 'cwe': 346, 'qualname': ['origin\\s*=\\s*request\\.headers\\.get\\(["\\\']Origin["\\\']\\)', 'if\\s*origin\\s*!=\\s*trusted_origin:', 'if\\s*not\\s*validate_origin\\(origin\\):', 'origin\\s*=\\s*request\\.headers\\.get\\(["\\\']Referer["\\\']\\)', 'if\\s*not\\s*origin\\s*or\\s*not\\s*is_valid_origin\\(origin\\):', 'origin\\s*=\\s*request\\.headers\\.get\\(["\\\']Host["\\\']\\)'], 'message': 'CWE (346, 942) Origin Validation Error, Permissive Cross-domain Policy with Untrusted Domains, Category A07:2021 - Identification and Authentication Failures', 'level': 'based on context'}, {'name': 'Cross-Site Request Forgery (CSRF)', 'bid': 24, 'cwe': 352, 'qualname': ['csrf_token\\s*=\\s*request\\.cookies\\.get\\(["\\\']csrf_token["\\\']\\)', 'csrf_token\\s*=\\s*request\\.headers\\.get\\(["\\\']X-CSRF-Token["\\\']\\)', 'csrf_token\\s*=\\s*request\\.args\\.get\\(["\\\']csrf_token["\\\']\\)', 'csrf_token\\s*=\\s*request\\.form\\.get\\(["\\\']csrf_token["\\\']\\)', 'if\\s*csrf_token\\s*!=\\s*session\\["\\\']csrf_token["\\\']:', 'if\\s*csrf_token\\s*!=\\s*request\\.headers\\.get\\(["\\\']X-CSRF-Token["\\\']\\):', 'if\\s*csrf_token\\s*!=\\s*request\\.args\\.get\\(["\\\']csrf_token["\\\']\\):', 'if\\s*csrf_token\\s*!=\\s*request\\.form\\.get\\(["\\\']csrf_token["\\\']\\):', 'csrf_token\\s*=\\s*request\\.cookies\\.get\\(["\\\']csrf_token["\\\']\\)', 'if\\s*not\\s*validate_csrf_token\\(csrf_token\\):'], 'message': 'CWE (352) Cross-Site Request Forgery (CSRF),  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, {'name': 'Insecure Temporary File', 'bid': 25, 'cwe': 732, 'qualname': ['tempfile\\.mktemp\\(', 'tempfile\\.TemporaryFile\\(', 'open\\(.*[, ]["\\\']w[+"\\\']\\)', 'open\\(.*[, ]["\\\']a[+"\\\']\\)', 'file\\.write\\(.*request\\.data\\)', 'file\\.write\\(.*input\\("Enter file contents: "\\)\\)', 'file\\.write\\(.*input\\("Enter file name: "\\)\\)', 'file\\.write\\(.*sys\\.argv\\[\\d\\]\\)', 'file\\.write\\(.*os\\.getenv\\("TEMP"\\)\\)'], 'message': 'CWE (377) Insecure Temporary File,  Category A01:2021 - Broken Access Control', 'level': 'based on context'}, {'name': 'Regular Expression Denial of Service (ReDoS', 'bid': 26, 'cwe': 400, 'qualname': ['\\b\\w*(\\w)\\1{3,}\\w*\\b', '\\b\\d+(\\d+)\\1{3,}\\d*\\b', '\\b[A-Za-z0-9_]+(?:\\.[A-Za-z0-9_]+)*@[A-Za-z0-9_]+(?:\\.[A-Za-z0-9_]+)+\\b', '\\b[a-z]+(?:-[a-z]+)*\\b', '\\b(?:[a-z]+)+\\b', '([a-zA-Z]+)\\1{4,}', '(a+)+\\s(b+)+', '^(a+)+$', '\\b[A-Za-z]+\\b'], 'message': 'CWE (400) Uncontrolled Resource Consumption', 'level': 'based on context'}, {'name': 'Insecure default value', 'bid': 27, 'cwe': 400, 'qualname': ['password\\s*=\\s*[\\\'"].*[\\\'"]', 'api_key\\s*=\\s*[\\\'"].*[\\\'"]', 'secret_key\\s*=\\s*[\\\'"].*[\\\'"]', 'token\\s*=\\s*[\\\'"].*[\\\'"]', 'key\\s*=\\s*[\\\'"].*[\\\'"]', 'passphrase\\s*=\\s*[\\\'"].*[\\\'"]', 'auth\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.username\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.password\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.key\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.secret\\s*=\\s*[\\\'"].*[\\\'"]', 'config\\.token\\s*=\\s*[\\\'"].*[\\\'"]'], 'message': 'CWE (453) Insecure Default Variable Initialization', 'level': 'based on context'}, {'name': 'Debug Mode Enabled', 'bid': 28, 'cwe': 489, 'qualname': ['debug\\s*=\\s*(True|true|1)', 'debug\\s*=\\s*(\\\'|\\")?on(\\\'|\\")?', 'debug\\s*=\\s*[\\\'"]?enabled[\\\'"]?', 'debug\\s*=\\s*(\\\'|\\")?yes(\\\'|\\")?'], 'message': 'CWE (489) Active Debug Code', 'level': 'based on context'}, {'name': 'Deserialization of Untrusted Data', 'bid': 29, 'cwe': 502, 'qualname': ['pickle\\.loads\\(', 'pickle\\.load\\(', 'dill\\.loads\\(', 'dill\\.load\\(', 'shelve\\.open\\(', 'jsonpickle\\.decode\\(', 'pandas\\.read_pickle\\(', 'marshal\\.loads\\(', 'marshal\\.load\\('], 'message': 'CWE (502) Deserialization of Untrusted Data, Category A08:2021 - Software and Data Integrity Failures', 'level': 'based on context'}, {'name': 'Hardcoded Secret', 'bid': 30, 'cwe': 547, 'qualname': ['password\\s*=\\s*[\\\'"].*[\\\'"]', 'api_key\\s*=\\s*[\\\'"].*[\\\'"]', 'token\\s*=\\s*[\\\'"].*[\\\'"]', 'secret\\s*=\\s*[\\\'"].*[\\\'"]'], 'message': 'CWE (547) Use of Hard-coded, Security-relevant Constants, Category A05:2021 - Security Misconfiguration', 'level': 'based on context'}, {'name': ' Open Redirect', 'bid': 31, 'cwe': 601, 'qualname': ['redirect\\s*=\\s*[\\\'"].*[\\\'"]', 'redirect_url\\s*=\\s*[\\\'"].*[\\\'"]', 'url\\s*=\\s*[\\\'"].*[\\\'"]', 'location\\s*=\\s*[\\\'"].*[\\\'"]', 'window\\.location\\s*=\\s*[\\\'"].*[\\\'"]'], 'message': "CWE (601) URL Redirection to Untrusted Site ('Open Redirect'), Category A01:2021 - Broken Access Control", 'level': 'based on context'}, {'name': 'Insecure Xml Parser', 'bid': 32, 'cwe': 611, 'qualname': ['xml\\.etree\\.cElementTree\\.parse', 'xml\\.etree\\.ElementTree\\.parse', 'xml\\.sax\\.parse', 'xml\\.dom\\.minidom\\.parse', 'xml\\.dom\\.pulldom\\.parse', 'lxml\\.etree\\.parse', 'lxml\\.etree\\.fromstring', 'lxml\\.etree\\.RestrictedElement', 'lxml\\.etree\\.GlobalParserTLS', 'lxml\\.etree\\.getDefaultParser', 'lxml\\.etree\\.check_docinfo'], 'message': 'CWE (611) Improper Restriction of XML External Entity Reference, Category A05:2021 - Security Misconfiguration', 'level': 'based on context'}, {'name': "Sensitive Cookie in HTTPS Session Without 'Secure' Attribute", 'bid': 33, 'cwe': 614, 'qualname': ['set-cookie:\\s*(?i)(?!.*\\bsecure\\b)(?=.*\\b(?:sessionid|auth|token)\\b)'], 'message': "CWE (614) Sensitive Cookie in HTTPS Session Without 'Secure' Attribute,  Category A05:2021 - Security Misconfiguration", 'level': 'based on context'}, {'name': ' XPath Injection', 'bid': 34, 'cwe': 643, 'qualname': ['\\.xpath\\(\\s*["\\\'][^"\\\']*{{user_input}}[^"\\\']*["\\\']\\s*\\)'], 'message': "CWE (643) Improper Neutralization of Data within XPath Expressions ('XPath Injection'), Category A03:2021 - Injection", 'level': 'based on context'}, {'name': 'Insecure File Permissions', 'bid': 35, 'cwe': 732, 'qualname': ['os\\.chmod\\(|os\\.chown\\(|os\\.umask\\(|os\\.open\\(|open\\(|os\\.makedirs\\(|shutil\\.copy2\\(|shutil\\.move\\(|os\\.rename\\(|tempfile\\.mkstemp\\(|tempfile\\.NamedTemporaryFile\\(|tempfile\\.TemporaryFile\\(|os\\.fdopen\\(|os\\.lchown\\(|os\\.chmod\\(|os\\.fchmod\\(|os\\.lchmod\\(|os\\.open\\(|os\\.mknod\\(|os\\.mmap\\(|os\\.utime\\('], 'message': 'CWE (732) Incorrect Permission Assignment for Critical Resource', 'level': 'based on context'}, {'name': 'Selection of Less-Secure Algorithm During Negotiation (SSL instead of TLS)', 'bid': 36, 'cwe': 327, 'qualname': ['ssl\\.(PROTOCOL_SSLv23|SSLContext|wrap_socket|create_default_context|_create_unverified_context)'], 'message': "CWE (757) Selection of Less-Secure Algorithm During Negotiation ('Algorithm Downgrade'),  Category A02:2021 - Cryptographic Failures", 'level': 'based on context'}, {'name': 'Use of Password Hash With Insufficient Computational Effort', 'bid': 37, 'cwe': 916, 'qualname': ['crypt\\.(crypt|crypt_sha256|crypt_sha512)|hashlib\\.(md5|sha1)', 'bcrypt\\.(hashpw|gensalt)', 'argon2\\.(hash_password|Hasher\\.hash\\(|PasswordHasher\\()', 'scrypt\\.(hash|encrypt)', 'passlib\\.(hash|pwd\\.)', '\\bPBKDF2\\b', '\\bsha256_crypt\\b', '\\bsha512_crypt\\b', '\\bmd5_crypt\\b', '\\bsha1_crypt\\b', '\\bsha256_pbkdf2\\b', '\\bsha512_pbkdf2\\b', '\\bargon2_cffi\\b', '\\bpycryptodome\\.(pbkdf2|hashers)\\b', '\\bpy-bcrypt\\b'], 'message': 'CWE (916) Use of Password Hash With Insufficient Computational Effort, Category A02:2021 - Cryptographic Failures', 'level': 'based on context'}, {'name': 'Server-Side Request Forgery (SSRF)', 'bid': 38, 'cwe': 918, 'qualname': ['\\burllib\\.request\\.(urlopen|urlretrieve|URLopener|FancyURLopener)|\\brequests\\.(get|head|post|put|patch|delete)', '\\bhttplib2\\.Http\\.request|tornado\\.httpclient\\.HTTPClient\\.fetch|aiohttp\\.ClientSession\\.(get|post|put|patch|delete)', '\\bhttp\\.client\\.HTTPConnection\\.request|http\\.client\\.HTTPSConnection\\.request', '\\bsocket\\.socket\\.connect\\b', '\\bparamiko\\.SSHClient\\.connect\\b', '\\bfabric\\.Connection\\.connect\\b', '\\bparamiko\\.SFTPClient\\.from_transport\\b', '\\bsocketserver\\.(TCPServer|UDPServer)\\b'], 'message': 'CWE (918) Server-Side Request Forgery (SSRF),  Category A10:2021 - Server-Side Request Forgery (SSRF)', 'level': 'based on context'}, {'name': 'NoSQL Injection', 'bid': 39, 'cwe': 943, 'qualname': ['\\bfind_one\\b', '\\bfind\\b', '\\bfind_and_modify\\b', '\\baggregate\\b', '\\bupdate\\b', '\\bremove\\b', '\\bdelete_one\\b', '\\bdelete_many\\b', '\\binsert\\b', '\\binsert_one\\b', '\\binsert_many\\b', '\\breplace_one\\b', '\\bdistinct\\b', '\\bmap_reduce\\b', '\\bdatabase\\.query\\b', '\\bdatabase\\.execute\\b', '\\bexecute_query\\b'], 'message': 'CWE (943) Improper Neutralization of Special Elements in Data Query Logic', 'level': 'based on context'}, {'name': "Sensitive Cookie Without 'HttpOnly' Flag", 'bid': 40, 'cwe': 1004, 'qualname': ['\\bset_cookie\\([^\\)]*HttpOnly\\b', '\\bSet-Cookie:.*HttpOnly\\b'], 'message': "CWE (1004) Sensitive Cookie Without 'HttpOnly' Flag, Category A05:2021 - Security Misconfiguration", 'level': 'based on context'}, {'name': ' Python 2 source code', 'bid': 41, 'cwe': 1104, 'qualname': ['\\bimport\\s+unmaintained_module\\b', '\\bfrom\\s+unmaintained_package\\b', '\\bunmaintained_module\\b', '\\bunmaintained_package\\b', "\\brequire\\(\\'unmaintained_package\\'\\)", '\\bimport \\(require\\("unmaintained_package"\\)\\)'], 'message': 'CWE (1104) Use of Unmaintained Third Party Components, Category A06:2021 - Vulnerable and Outdated Components', 'level': 'based on context'}]
ilist = [{'name': 'pickle', 'bid': 'B301', 'cwe': 502, 'qualname': ['pickle.loads', 'pickle.load', 'pickle.Unpickler', 'dill.loads', 'dill.load', 'dill.Unpickler', 'shelve.open', 'shelve.DbfilenameShelf', 'jsonpickle.decode', 'jsonpickle.unpickler.decode', 'jsonpickle.unpickler.Unpickler', 'pandas.read_pickle'], 'message': 'Pickle and modules that wrap it can be unsafe when used to deserialize untrusted data, possible security ', 'level': 'MEDUIM'}, {'name': 'marshal', 'bid': 'B302', 'cwe': 502, 'qualname': ['marshal.load', 'marshal.loads'], 'message': 'Deserialization with the marshal module is possibly dangerous.', 'level': 'MEDUIM'}, {'name': 'md5', 'bid': 'B303', 'cwe': 327, 'qualname': ['Crypto.Hash.MD2.new', 'Crypto.Hash.MD4.new', 'Crypto.Hash.MD5.new', 'Crypto.Hash.SHA.new', 'Cryptodome.Hash.MD2.new', 'Cryptodome.Hash.MD4.new', 'Cryptodome.Hash.MD5.new', 'Cryptodome.Hash.SHA.new', 'cryptography.hazmat.primitives.hashes.MD5', 'cryptography.hazmat.primitives.hashes.SHA1'], 'message': 'Use of insecure MD2, MD4, MD5, or SHA1 hash function.', 'level': 'MEDUIM'}, {'name': 'md5', 'bid': 'B303', 'cwe': 327, 'qualname': ['hashlib.md4', 'hashlib.md5', 'hashlib.sha', 'hashlib.sha1', 'Crypto.Hash.MD2.new', 'Crypto.Hash.MD4.new', 'Crypto.Hash.MD5.new', 'Crypto.Hash.SHA.new', 'Cryptodome.Hash.MD2.new', 'Cryptodome.Hash.MD4.new', 'Cryptodome.Hash.MD5.new', 'Cryptodome.Hash.SHA.new', 'cryptography.hazmat.primitives.hashes.MD5', 'cryptography.hazmat.primitives.hashes.SHA1'], 'message': 'Use of insecure MD2, MD4, MD5, or SHA1 hash function.', 'level': 'MEDUIM'}, {'name': 'ciphers', 'bid': 'B304', 'cwe': 327, 'qualname': ['Crypto.Cipher.ARC2.new', 'Crypto.Cipher.ARC4.new', 'Crypto.Cipher.Blowfish.new', 'Crypto.Cipher.DES.new', 'Crypto.Cipher.XOR.new', 'Cryptodome.Cipher.ARC2.new', 'Cryptodome.Cipher.ARC4.new', 'Cryptodome.Cipher.Blowfish.new', 'Cryptodome.Cipher.DES.new', 'Cryptodome.Cipher.XOR.new', 'cryptography.hazmat.primitives.ciphers.algorithms.ARC4', 'cryptography.hazmat.primitives.ciphers.algorithms.Blowfish', 'cryptography.hazmat.primitives.ciphers.algorithms.IDEA'], 'message': 'Use of insecure cipher {name}. Replace with a known secure cipher such as AES.', 'level': 'HIGH'}, {'name': 'cipher_modes', 'bid': 'B305', 'cwe': 327, 'qualname': ['cryptography.hazmat.primitives.ciphers.modes.ECB'], 'message': 'Use of insecure cipher mode {name}.', 'level': 'MEDUIM'}, {'name': 'mktemp_q', 'bid': 'B306', 'cwe': 377, 'qualname': ['tempfile.mktemp'], 'message': 'Use of insecure and deprecated function (mktemp).', 'level': 'MEDUIM'}, {'name': 'eval', 'bid': 'B307', 'cwe': 78, 'qualname': ['eval'], 'message': 'Use of possibly insecure function - consider using safer ast.literal_eval.', 'level': 'MEDUIM'}, {'name': 'mark_safe', 'bid': 'B308', 'cwe': 79, 'qualname': ['django.utils.safestring.mark_safe'], 'message': 'Use of mark_safe() may expose cross-site scripting vulnerabilities and should be reviewed.', 'level': 'MEDUIM'}, {'name': 'urllib_urlopen', 'bid': 'B310', 'cwe': 22, 'qualname': ['urllib.request.urlopen', 'urllib.request.urlretrieve', 'urllib.request.URLopener', 'urllib.request.FancyURLopener', 'six.moves.urllib.request.urlopen', 'six.moves.urllib.request.urlretrieve', 'six.moves.urllib.request.URLopener', 'six.moves.urllib.request.FancyURLopener'], 'message': 'Audit url open for permitted schemes. Allowing use of file:/ or custom schemes is often unexpected.', 'level': 'MEDUIM'}, {'name': 'random', 'bid': 'B311', 'cwe': 330, 'qualname': ['random.Random', 'random.random', 'random.randrange', 'random.randint', 'random.choice', 'random.choices', 'random.uniform', 'random.triangular', 'random.randbytes'], 'message': 'Standard pseudo-random generators are not suitable for security/cryptographic purposes.', 'level': 'LOW'}, {'name': 'telnetlib', 'bid': 'B312', 'cwe': 319, 'qualname': ['telnetlib.*'], 'message': 'Telnet-related functions are being called. Telnet is considered insecure. Use SSH or some other encrypted protocol.', 'level': 'HIGH'}, {'name': 'xml_bad_cElementTree', 'bid': 'B313', 'cwe': 20, 'qualname': ['xml.etree.cElementTree.parse', 'xml.etree.cElementTree.iterparse', 'xml.etree.cElementTree.fromstring', 'xml.etree.cElementTree.XMLParser'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_ElementTree', 'bid': 'B314', 'cwe': 20, 'qualname': ['xml.etree.ElementTree.parse', 'xml.etree.ElementTree.iterparse', 'xml.etree.ElementTree.fromstring', 'xml.etree.ElementTree.XMLParser'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_expatreader', 'bid': 'B315', 'cwe': 20, 'qualname': ['xml.sax.expatreader.create_parser'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_expatbuilder', 'bid': 'B316', 'cwe': 20, 'qualname': ['xml.dom.expatbuilder.parse', 'xml.dom.expatbuilder.parseString'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_sax', 'bid': 'B317', 'cwe': 20, 'qualname': ['xml.sax.parse', 'xml.sax.parseString', 'xml.sax.make_parser'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_minidom', 'bid': 'B318', 'cwe': 20, 'qualname': ['xml.dom.minidom.parse', 'xml.dom.minidom.parseString'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_pulldom', 'bid': 'B319', 'cwe': 20, 'qualname': ['xml.dom.pulldom.parse', 'xml.dom.pulldom.parseString'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function or make sure defusedxml.defuse_stdlib() is called', 'level': 'MEDUIM'}, {'name': 'xml_bad_etree', 'bid': 'B320', 'cwe': 20, 'qualname': ['lxml.etree.parse', 'lxml.etree.fromstring', 'lxml.etree.RestrictedElement', 'lxml.etree.GlobalParserTLS', 'lxml.etree.getDefaultParser', 'lxml.etree.check_docinfo'], 'message': 'Using {name} to parse untrusted XML data is known to be vulnerable to XML attacks. Replace {name} with its defusedxml equivalent function.', 'level': 'MEDUIM'}, {'name': 'ftplib', 'bid': 'B321', 'cwe': 319, 'qualname': ['ftplib.*'], 'message': 'FTP-related functions are being called. FTP is considered insecure. Use SSH/SFTP/SCP or some other encrypted protocol.', 'level': 'HIGH'}, {'name': 'unverified_context', 'bid': 'B323', 'cwe': 295, 'qualname': ['ssl._create_unverified_context'], 'message': 'By default, Python will create a secure, verified ssl context for use in such classes as HTTPSConnection. However, it still allows using an insecure context via the _create_unverified_context that  reverts to the previous behavior that does not validate certificates or perform hostname checks.', 'level': 'MEDUIM'}]
# dump = Module(body=[Import(names=[alias(name='os')]), Import(names=[alias(name='subprocess')]), ImportFrom(module='lxml', names=[alias(name='etree')], level=0), Assign(targets=[Name(id='url', ctx=Store())], value=Call(func=Attribute(value=Name(id='req', ctx=Load()), attr='param', ctx=Load()), args=[Constant(value='url')], keywords=[])), Expr(value=Call(func=Attribute(value=Name(id='os', ctx=Load()), attr='system', ctx=Load()), args=[Constant(value='ls')], keywords=[])), Assign(targets=[Name(id='file_path', ctx=Store())], value=Constant(value='../etc/passwd')), Expr(value=Call(func=Attribute(value=Name(id='subprocess', ctx=Load()), attr='run', ctx=Load()), args=[Constant(value='ls')], keywords=[])), Expr(value=Call(func=Name(id='mark_safe', ctx=Load()), args=[Constant(value="<script>alert('XSS')</script>")], keywords=[])), Assign(targets=[Name(id='template', ctx=Store())], value=Constant(value='{{ user_input }}')), Assign(targets=[Name(id='query', ctx=Store())], value=BinOp(left=BinOp(left=Constant(value="SELECT * FROM users WHERE name = '"), op=Add(), right=Name(id='user_input', ctx=Load())), op=Add(), right=Constant(value="'")))], type_ignores=[])